Player james;
Snake serp;
BallChase mace;
Sword sam;
GreenWolf greenDog;

int[] deadBoss = new int[3];
PImage[] cauldron = new PImage[8];
PImage cauldronCurrent;

int screenNumber;
boolean up = false;
boolean down = false;
boolean left = false;
boolean right = false;
boolean hitWallUp = false;
boolean hitWallDown = false;
boolean hitWallLeft = false;
boolean hitWallRight = false;
boolean hitWallUpBoss = false;
boolean hitWallDownBoss = false;
boolean hitWallLeftBoss = false;
boolean hitWallRightBoss = false;

boolean canAttackUp = true;
boolean canAttackDown = true;
boolean canAttackLeft = true;
boolean canAttackRight = true;

boolean attackUp = false;
boolean attackDown = false;
boolean attackLeft = false;
boolean attackRight = false;
int attackTimerMax;
int attackTimerUp;
int attackTimerDown;
int attackTimerLeft;
int attackTimerRight;
int gotHit;

boolean snakeDead = false;
boolean spikeDead = false;
boolean samDead = false;
boolean finalBossDead = false;
boolean gameOver = false;
boolean gameWon = false;

int finalBossSpawn;

PImage Dungon;
PImage Cauldron;
PImage Spike;


int northDoorX;
int northDoorY;
int northDoorWidth;
int northDoorHeight;
int eastDoorX;
int eastDoorY;
int eastDoorWidth;
int eastDoorHeight;
int southDoorX;
int southDoorY;
int southDoorWidth;
int southDoorHeight;
int westDoorX;
int westDoorY;
int westDoorWidth;
int westDoorHeight;

float startX;
float startY;
float startW;
float startH;
PImage startButton;
PImage Title;
float resetW;
float resetH;
float resetX;
float resetY;
PImage GameOver;
PImage WinScreen;

void setup() {
  size(750, 500);
  james = new Player();
  serp = new Snake();
  mace = new BallChase();
  sam = new Sword();
  greenDog = new GreenWolf();

  for (int i = 0; i<3; i++) {
    deadBoss[i] = -1;
  }

  attackTimerMax = 60;

  northDoorX = width/2-25;
  northDoorY = 0;
  northDoorWidth = 50;
  northDoorHeight = 15;
  eastDoorX = width-10;
  eastDoorY = height/2-25;
  eastDoorWidth = 15;
  eastDoorHeight = 50;
  southDoorX = width/2-25;
  southDoorY = height-10;
  southDoorWidth = 50;
  southDoorHeight = 15;
  westDoorX = 0;
  westDoorY = height/2-25;
  westDoorWidth = 10;
  westDoorHeight = 50;

  startX = 308;
  startY = 428;
  startW = 133;
  startH = 22;
  startButton = loadImage("StartButton.png");
  Title = loadImage("TitleScreen.png");
  GameOver = loadImage("GameOver.png");
  WinScreen = loadImage("WinScreen.png");
  resetW = 188;
  resetH = 22;
  resetX = 281;
  resetY = 428;

  screenNumber = 1;
  Dungon = loadImage("Dungon.png");
  Spike = loadImage("spike.png");

  finalBossSpawn = 0;
}

void draw() {
  if (gameOver == false && gameWon == false) {

    if (screenNumber == 1) {
      imageMode(CORNER);
      image(Title, 0, 0);
    }

    //Main Room
    if (screenNumber == 2) {
      background(255);
      imageMode(CORNER);
      image(Dungon, 0, 0);
      if (deadBoss[0] == -1 && deadBoss[1] == -1 && deadBoss[2] == -1) {
        cauldronCurrent = loadImage("cauldron.png");
      }
      if (deadBoss[0] == 1 && deadBoss[1] == -1 && deadBoss[2] == -1) {
        cauldronCurrent = loadImage("cauldron_s.png");
      }
      if (deadBoss[0] == 1 && deadBoss[1] == 2 && deadBoss[2] == -1) {
        cauldronCurrent = loadImage("cauldron_ts.png");
      }
      if (deadBoss[0] == 1 && deadBoss[1] == 3 && deadBoss[2] == -1) {
        cauldronCurrent = loadImage("cauldron_te.png");
      }
      if (deadBoss[0] == 1 && deadBoss[1] == 2 && deadBoss[2] == 3) {
        cauldronCurrent = loadImage("cauldron_all.png");
      }
      if (deadBoss[0] == 1 && deadBoss[1] == 3 && deadBoss[2] == 2) {
        cauldronCurrent = loadImage("cauldron_all.png");
      }
      if (deadBoss[0] == 2 && deadBoss[1] == -1 && deadBoss[2] == -1) {
        cauldronCurrent = loadImage("cauldron_t.png");
      }
      if (deadBoss[0] == 2 && deadBoss[1] == 1 && deadBoss[2] == -1) {
        cauldronCurrent = loadImage("cauldron_ts.png");
      }
      if (deadBoss[0] == 2 && deadBoss[1] == 3 && deadBoss[2] == -1) {
        cauldronCurrent = loadImage("cauldron_te.png");
      }
      if (deadBoss[0] == 2 && deadBoss[1] == 3 && deadBoss[2] == 1) {
        cauldronCurrent = loadImage("cauldron_all.png");
      }
      if (deadBoss[0] == 2 && deadBoss[1] == 1 && deadBoss[2] == 3) {
        cauldronCurrent = loadImage("cauldron_all.png");
      }
      if (deadBoss[0] == 3 && deadBoss[1] == -1 && deadBoss[2] == -1) {
        cauldronCurrent = loadImage("cauldron_e.png");
      }
      if (deadBoss[0] == 3 && deadBoss[1] == 1 && deadBoss[2] == -1) {
        cauldronCurrent = loadImage("cauldron_se.png");
      }
      if (deadBoss[0] == 3 && deadBoss[1] == 2 && deadBoss[2] == -1) {
        cauldronCurrent = loadImage("cauldron_te.png");
      }
      if (deadBoss[0] == 3 && deadBoss[1] == 2 && deadBoss[2] == 1) {
        cauldronCurrent = loadImage("cauldron_all.png");
      }
      if (deadBoss[0] == 3 && deadBoss[1] == 1 && deadBoss[2] == 2) {
        cauldronCurrent = loadImage("cauldron_all.png");
      }
      imageMode(CENTER);
      image(cauldronCurrent, width/2, 100);
      james.drawPlayer();
      james.updatePlayer();
      fill(152, 104, 40);
      rect(eastDoorX, eastDoorY, eastDoorWidth, eastDoorHeight);
      rect(southDoorX, southDoorY, southDoorWidth, southDoorHeight);
      rect(westDoorX, westDoorY, westDoorWidth, westDoorHeight);
      if (james.x > eastDoorX && james.x < eastDoorX+eastDoorWidth && james.y > eastDoorY && james.y < eastDoorY+eastDoorHeight && screenNumber == 2 && spikeDead == false) {
        screenNumber = 3;
        james.resetPlayerLeft();
      }
      if (james.x > southDoorX && james.x < southDoorX+southDoorWidth && james.y > southDoorY && james.y < southDoorY+southDoorHeight && screenNumber == 2 && snakeDead==false) {
        screenNumber = 4;
        james.resetPlayerTop();
      }
      if (james.x > westDoorX && james.x < westDoorX+westDoorWidth && james.y > westDoorY && james.y < westDoorY+westDoorHeight && screenNumber == 2 && samDead == false) {
        screenNumber = 5;
        james.resetPlayerRight();
      }
      if (snakeDead == true && spikeDead == true && samDead == true) {
        finalBossSpawn++;
        if (finalBossSpawn>=0 && finalBossSpawn<300) {
          textAlign(CENTER);
          textSize(20);
          fill(0);
          text("You have done well to make it this far.", width/2, height/2-5);
        }
        if (finalBossSpawn>=300 && finalBossSpawn<600) {
          textAlign(CENTER);
          textSize(20);
          fill(0);
          text("But the journey so far has been child's play", width/2, height/2-5);
          text("compared to what's to come.", width/2, height/2+17);
        }
        if (finalBossSpawn>=600 && finalBossSpawn<900) {
          textAlign(CENTER);
          textSize(20);
          fill(0);
          text("Now you face your greatest challenge!", width/2, height/2-5);
        }
        if (finalBossSpawn>=900 && finalBossDead == false) {
          greenDog.drawFinal();
          greenDog.updateFinal();
          gotHit--;
          float distancePlayerF = dist(james.x, james.y, greenDog.x, greenDog.y);
          if (distancePlayerF<greenDog.finalSize/2 && gotHit<=0) {
            james.health-=greenDog.power;
            gotHit = 120;
          }
          float distanceThrustF = dist(james.swordX, james.swordY, greenDog.x, greenDog.y);
          if (distanceThrustF < 60 && attackUp == true) {
            greenDog.health-=james.swordPower;
            attackUp = false;
          }
          if (distanceThrustF < 60 && attackDown == true) {
            greenDog.health-=james.swordPower;
            attackDown = false;
          }
          if (distanceThrustF < 60 && attackLeft == true) {
            greenDog.health-=james.swordPower;
            attackLeft = false;
          }
          if (distanceThrustF < 60 && attackRight == true) {
            greenDog.health-=james.swordPower;
            attackRight = false;
          }

          if (greenDog.health<=0) {
            finalBossDead = true;
          }
        }
        if (finalBossSpawn>=900 && finalBossDead == true) {
          gameWon = true;
        }
      }
    }
    //Room to the right Mace Man
    if (screenNumber == 3) {
      background (0, 0, 255);
      imageMode(CORNER);
      image(Dungon, 0, 0);
      if (mace.health>0) {
        mace.drawBall();
        mace.updateBallXneo();
      }
      if (mace.health<=0 && spikeDead == false) {
        mace.clearBody();
        spikeDead = true;
        for (int i = 0; i<3; i++) {
          if (deadBoss[i] == -1) {
            deadBoss[i] = mace.bossID;
            println(deadBoss[0]);
            break;
          }
        }
      }
      james.drawPlayer();
      james.updatePlayer();

      fill(0);
      rect(westDoorX, westDoorY, 10, 50);
      if (james.x > westDoorX && james.x < westDoorX+westDoorWidth && james.y > westDoorY && james.y < westDoorY+westDoorHeight && screenNumber == 3 && spikeDead == true) {
        screenNumber = 2;
        james.health = 100;
        james.resetPlayerRight();
      }
      gotHit--;
      float distancePlayerS = dist(james.x, james.y, mace.x, mace.y);
      if (distancePlayerS<58 && gotHit<=0) {
        james.health-=mace.power;
        gotHit = 120;
      }
      float distanceThrustS = dist(james.swordX, james.swordY, mace.x, mace.y);
      if (distanceThrustS < 60 && attackUp == true) {
        println("You hit the Spike Up");
        mace.health-=james.swordPower;
        attackUp = false;
      }
      if (distanceThrustS < 60 && attackDown == true) {
        println("You hit the Spike Down");
        mace.health-=james.swordPower;
        attackDown = false;
      }
      if (distanceThrustS < 60 && attackLeft == true) {
        println("You hit the Spike Left");
        mace.health-=james.swordPower;
        attackLeft = false;
      }
      if (distanceThrustS < 60 && attackRight == true) {
        println("You hit the Spike Right");
        mace.health-=james.swordPower;
        attackRight = false;
      }
    }
    //This is the snake boss room
    if (screenNumber == 4) {
      background (255, 0, 255);
      imageMode(CORNER);
      image(Dungon, 0, 0);
      fill(0, 255, 0);
      if (serp.health>0) {
        serp.drawSnake();
        serp.updateSnake();
      }
      if (serp.health<=0 && snakeDead == false) {
        serp.clearBody();
        snakeDead = true;
        for (int i = 0; i<3; i++) {
          if (deadBoss[i] == -1) {
            deadBoss[i] = serp.bossID;
            println(deadBoss[0]);
            break;
          }
        }
      }
      james.drawPlayer();
      james.updatePlayer();
      fill(0);
      rect(northDoorX, northDoorY, northDoorWidth, northDoorHeight);
      if (james.x > northDoorX && james.x < northDoorX+northDoorWidth && james.y > northDoorY && james.y < northDoorY+northDoorHeight && screenNumber == 4 && snakeDead == true) {
        screenNumber = 2;
        james.health = 100;
        james.resetPlayerBottom();
      }
      gotHit--;
      float distancePlayer = dist(james.x, james.y, serp.SnakeHeadX, serp.SnakeHeadY);
      if (distancePlayer<38 && gotHit<=0) {
        james.health-=serp.power;
        gotHit = 120;
      }
      float distanceThrustH = dist(james.swordX, james.swordY, serp.SnakeHeadX, serp.SnakeHeadY);
      if (distanceThrustH < 60 && attackUp == true) {
        println("You hit the snake Up");
        serp.health-=james.swordPower;
        attackUp = false;
      }
      if (distanceThrustH < 60 && attackDown == true) {
        println("You hit the snake Down");
        serp.health-=james.swordPower;
        attackDown = false;
      }
      if (distanceThrustH < 60 && attackLeft == true) {
        println("You hit the snake Left");
        serp.health-=james.swordPower;
        attackLeft = false;
      }  
      if (distanceThrustH < 60 && attackRight == true) {
        println("You hit the snake Right");
        serp.health-=james.swordPower;
        attackRight = false;
      }
      float distanceThrust1 = dist(james.swordX, james.swordY, serp.SnakeBody1X, serp.SnakeBody1Y);
      if (distanceThrust1 < 45 && attackUp == true) {
        println("You hit the snake body 1 Up");
        serp.health-=james.swordPower;
        attackUp = false;
      }
      if (distanceThrust1 < 45 && attackDown == true) {
        println("You hit the snake body 1 Down");
        serp.health-=james.swordPower;
        attackDown = false;
      }
      if (distanceThrust1 < 45 && attackLeft == true) {
        println("You hit the snake body 1 Left");
        serp.health-=james.swordPower;
        attackLeft = false;
      }  
      if (distanceThrust1 < 45 && attackRight == true) {
        println("You hit the snake body 1 Right");
        serp.health-=james.swordPower;
        attackRight = false;
      }
      float distanceThrust2 = dist(james.swordX, james.swordY, serp.SnakeBody2X, serp.SnakeBody2Y);
      if (distanceThrust2 < 45 && attackUp == true) {
        println("You hit the snake body 2 Up");
        serp.health-=james.swordPower;
        attackUp = false;
      }
      if (distanceThrust2 < 45 && attackDown == true) {
        println("You hit the snake body 2 Down");
        serp.health-=james.swordPower;
        attackDown = false;
      }
      if (distanceThrust2 < 45 && attackLeft == true) {
        println("You hit the snake body 2 Left");
        serp.health-=james.swordPower;
        attackLeft = false;
      }  
      if (distanceThrust2 < 45 && attackRight == true) {
        println("You hit the snake body 2 Right");
        serp.health-=james.swordPower;
        attackRight = false;
      }
      float distanceThrust3 = dist(james.swordX, james.swordY, serp.SnakeBody3X, serp.SnakeBody3Y);
      if (distanceThrust2 < 45 && attackUp == true) {
        println("You hit the snake body 3 Up");
        serp.health-=james.swordPower;
        attackUp = false;
      }
      if (distanceThrust3 < 45 && attackDown == true) {
        println("You hit the snake body 3 Down");
        serp.health-=james.swordPower;
        attackDown = false;
      }
      if (distanceThrust3 < 45 && attackLeft == true) {
        println("You hit the snake body 3 Left");
        serp.health-=james.swordPower;
        attackLeft = false;
      }  
      if (distanceThrust3 < 45 && attackRight == true) {
        println("You hit the snake body 3 Right");
        serp.health-=james.swordPower;
        attackRight = false;
      }
      float distanceThrust4 = dist(james.swordX, james.swordY, serp.SnakeBody4X, serp.SnakeBody4Y);
      if (distanceThrust2 < 45 && attackUp == true) {
        println("You hit the snake body 4 Up");
        serp.health-=james.swordPower;
        attackUp = false;
      }
      if (distanceThrust4 < 45 && attackDown == true) {
        println("You hit the snake body 4 Down");
        serp.health-=james.swordPower;
        attackDown = false;
      }
      if (distanceThrust4 < 45 && attackLeft == true) {
        println("You hit the snake body 4 Left");
        serp.health-=james.swordPower;
        attackLeft = false;
      }  
      if (distanceThrust4 < 45 && attackRight == true) {
        println("You hit the snake body 4 Right");
        serp.health-=james.swordPower;
        attackRight = false;
      }
    }
    if (screenNumber == 5) {
      background (0, 255, 255);
      imageMode(CORNER);
      image(Dungon, 0, 0);
      fill(0);
      if (sam.health>0) {
        sam.drawSword();
        sam.updateSword();
      }
      if (sam.health<=0 && samDead == false) {
        sam.clearBody();
        samDead = true;
        for (int i = 0; i<3; i++) {
          if (deadBoss[i] == -1) {
            deadBoss[i] = sam.bossID;
            println(deadBoss[0]);
            break;
          }
        }
      }
      gotHit--;
      float distancePlayerSam = dist(james.x, james.y, sam.x, sam.y);
      if (distancePlayerSam<90 && gotHit<=0 && sam.killZone ==true) {
        james.health-=sam.power;
        println(sam.attackTime);
        gotHit = 120;
      }
      float distanceThrustSam = dist(james.swordX, james.swordY, sam.x, sam.y);
      if (distanceThrustSam < 80 && attackUp == true) {
        println("You hit the sam Up");
        sam.health-=james.swordPower;
        attackUp = false;
      }
      if (distanceThrustSam < 80 && attackDown == true) {
        println("You hit the sam Down");
        sam.health-=james.swordPower;
        attackDown = false;
      }
      if (distanceThrustSam < 80 && attackLeft == true) {
        println("You hit the sam Left");
        sam.health-=james.swordPower;
        attackLeft = false;
      }
      if (distanceThrustSam < 80 && attackRight == true) {
        println("You hit the sam Right");
        sam.health-=james.swordPower;
        attackRight = false;
      }
      james.drawPlayer();
      james.updatePlayer();
      fill(0);
      rect(eastDoorX, eastDoorY, eastDoorWidth, eastDoorHeight);
      if (james.x > eastDoorX && james.x < eastDoorX+eastDoorWidth && james.y > eastDoorY && james.y < eastDoorY+eastDoorHeight && screenNumber == 5 && samDead == true) {
        screenNumber = 2;
        james.health = 100;
        james.resetPlayerLeft();
      }
    }

    attackTimerUp--;
    attackTimerDown--;
    attackTimerLeft--;
    attackTimerRight--;

    if (attackTimerUp <=0) {
      attackUp = false;
    }
    if (attackTimerDown <=0) {
      attackDown = false;
    }
    if (attackTimerLeft <=0) {
      attackLeft = false;
    }
    if (attackTimerRight <=0) {
      attackRight = false;
    }
  }
  if (gameOver == true) {
    imageMode(CORNER);
    image(GameOver, 0, 0);
  }
  if (gameWon == true) {
    imageMode(CORNER);
    image(WinScreen, 0, 0);
  }
  if (attackTimerUp<=0) {
    canAttackUp = true;
  }
  if (attackTimerDown<=0) {
    canAttackDown = true;
  }
  if (attackTimerLeft<=0) {
    canAttackLeft = true;
  }
  if (attackTimerRight<=0) {
    canAttackRight= true;
  }
}


void keyPressed() {
  if (key == 'w') {
    up = true;
  }
  if (key == 's') {
    down = true;
  }
  if (key == 'a') {
    left = true;
  }
  if (key == 'd') {
    right = true;
  }
  if (keyCode == UP && canAttackUp == true) {
    attackUp = true;
    canAttackUp = false;
    attackTimerUp = attackTimerMax;
  }
  if (keyCode == DOWN && canAttackDown == true) {
    attackDown = true;
    canAttackDown = false;
    attackTimerDown = attackTimerMax;
  }
  if (keyCode == LEFT && canAttackLeft == true) {
    attackLeft = true;
    canAttackLeft = false;
    attackTimerLeft = attackTimerMax;
  }
  if (keyCode == RIGHT && canAttackRight == true) {
    attackRight = true;
    canAttackRight = false;
    attackTimerRight = attackTimerMax;
  }
}

void keyReleased() {
  if (key == 'w') {
    up = false;
  }
  if (key == 's') {
    down = false;
  }
  if (key == 'a') {
    left = false;
  }
  if (key == 'd') {
    right = false;
  }
  if (keyCode == UP && attackTimerUp<=0) {
    canAttackUp = true;
  }
  if (keyCode == DOWN && attackTimerDown<=0) {
    canAttackDown = true;
  }
  if (keyCode == LEFT && attackTimerLeft<=0) {
    canAttackLeft = true;
  }
  if (keyCode == RIGHT && attackTimerRight<=0) {
    canAttackRight = true;
  }
}

void mousePressed() {
  if (mouseX > startX && mouseX < startX+startW && mouseY > startY&& mouseY < startY+startH && screenNumber == 1) {
    screenNumber = 2;
  }
  if (mouseX > resetX && mouseX < resetX+resetW && mouseY > resetY&& mouseY < resetY+resetH && gameOver == true) {
    gameOver = false;
    screenNumber = 1;
    spikeDead = false;
    snakeDead = false;
    samDead = false;
    james.reset();
    mace.reset();
    serp.reset();
    sam.reset();
    greenDog.reset();
    for (int i = 0; i<3; i++) {
      deadBoss[i] = -1;
    }
  }
  if (mouseX > resetX && mouseX < resetX+resetW && mouseY > resetY&& mouseY < resetY+resetH && gameWon == true) {
    gameWon = false;
    screenNumber = 1;
    spikeDead = false;
    snakeDead = false;
    samDead = false;
    finalBossDead = false;
    finalBossSpawn =0;
    james.reset();
    mace.reset();
    serp.reset();
    sam.reset();
    greenDog.reset();
    for (int i = 0; i<3; i++) {
      deadBoss[i] = -1;
    }
  }
}