class Player {
  float x = width/2;
  float y = height/2;
  float size = 25;
  float speed = 4;
  float playerX;
  float playerY;
  float health = 100;
  float swordX;
  float swordY;
  float swordPower = 15;
  PImage Player = loadImage("PlayerDown.png");
  PImage swordUp = loadImage("SwordUp.png");
  PImage swordDown = loadImage("SwordDown.png");
  PImage swordLeft = loadImage("SwordLeft.png");
  PImage swordRight = loadImage("SwordRight.png");


  void drawPlayer() {
    fill(0,0,255);
    rect(10,10,health,20);
    imageMode(CENTER);
    image(Player,x,y);
    playerX = x;
    playerY = y;
  }

  void updatePlayer() {

    if (x <=0) {
      hitWallLeft = true;
    } else {
      hitWallLeft = false;
    }
    if (x>=width) {
      hitWallRight = true;
    } else {
      hitWallRight = false;
    }
    if (y<=0) {
      hitWallUp = true;
    } else {
      hitWallUp = false;
    }
    if (y>=height) {
      hitWallDown = true;
    } else {
      hitWallDown = false;
    }

    if (up == true && hitWallUp == false) {
      Player = loadImage("PlayerUp.png");
      y -=speed;
    }
    if (down == true && hitWallDown == false) {
      Player = loadImage("PlayerDown.png");
      y += speed;
    }
    if (left == true && hitWallLeft == false) {
      Player = loadImage("PlayerLeft.png");
      x -=speed;
    }
    if (right == true && hitWallRight == false) {
      Player = loadImage("PlayerRight.png");
      x +=speed;
    }
    if (attackTimerUp>30) {
      //println("Hit"+ attackTimerUp);
      swordX = x-5;
      swordY = y-40;
      imageMode(CORNER);
      image(swordUp,swordX,swordY);
      //rect(swordX, swordY, 10, 20);
    }
    if (attackTimerDown>30) {
      //println("Hit"+ attackTimerDown);
      swordX = x-5;
      swordY = y+10;
      imageMode(CORNER);
      image(swordDown,swordX,swordY-5);
      //rect(swordX, swordY, 10, 20);
    }
    if (attackTimerLeft>30) {
      //println("Hit"+ attackTimerLeft);
      swordX = x-25;
      swordY = y;
      image(swordLeft,swordX,swordY);
      //rect(swordX, swordY, 20, 10);
    }
    if (attackTimerRight>30) {
      //println("Hit"+ attackTimerRight);
      swordX = x+25;
      swordY = y;
      image(swordRight,swordX,swordY);
      //rect(swordX, swordY, 20, 10);
    }
    
    if(health<=0){
      gameOver = true;
    }
  }

  void resetPlayerLeft() {
    x = 30;
    y = height/2;
  }
  void resetPlayerRight() {
    x = width-30;
    y = height/2;
  }
  void resetPlayerTop() {
    x = width/2;
    y = 30;
  }
  void resetPlayerBottom() {
    x = width/2;
    y = height-30;
  }
  
  void reset(){
    x= width/2;
    y = height/2;
    health = 100;
    gotHit = 0;
  }
}